#version 430

layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

uniform mat4 view;
uniform mat4 projection;

in vData { float TTL1; } vertex[];
flat out float TTL0;

void main (void) {
	const vec2 size = vec2(0.4, 0.4);
	vec4 position = gl_in[0].gl_Position;

	vec2 bottom_left = position.xy + vec2(-0.2, -0.2) * size;
	gl_Position = projection * vec4(bottom_left, position.zw);
	TTL0 = vertex[0].TTL1;
	EmitVertex();

	vec2 bottom_right = position.xy + vec2(0.2, -0.2) * size;
	gl_Position = projection * vec4(bottom_right, position.zw);
	TTL0 = vertex[0].TTL1;
	EmitVertex();

	vec2 top_left = position.xy + vec2(-0.2, 0.2) * size;
	gl_Position = projection * vec4(top_left, position.zw);
	TTL0 = vertex[0].TTL1;
	EmitVertex();

	vec2 top_right = position.xy + vec2(0.2, 0.2) * size;
	gl_Position = projection * vec4(top_right, position.zw);
	TTL0 = vertex[0].TTL1;
	EmitVertex();

	EndPrimitive();
}